///home/berryj/link/bin/genMethods "-g" "-t" "Set<int>" "-h" "Collection" "-c" "int" "-I" "LINK/stkWrapper/SetFuncsWrapper.h" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Set.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/stkWrapper/SetFuncsWrapper.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Set<int> _Set_int_;
typedef Collection<Set<int> > _Collection_Set_int__;

#define _Collection_Set_int__DATA(x) ((Collection<Set<int> >*) (EXTDATA(x)))
#define _Collection_Set_int__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<int> > >::type))
#define _Collection_Set_int__ISNT_DATA(x) (!_Collection_Set_int__IS_DATA(x))

#define _Collection_Set_int__CXX_DATA(x) (*(Collection<Set<int> >*) (EXTDATA(VAL(x))))
#define _Collection_Set_int__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<int> > >::type))
#define _Collection_Set_int__CXX_ISNT_DATA(x) (!_Collection_Set_int__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Set_int__()
{
	Wrapper<_Collection_Set_int__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Set_int__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Set_int_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_int_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_int_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Set_int__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Set_int__Methods(void);

PRIMITIVE STk_init_methods__Collection_Set_int__()
{
	STk_add_new_cpp_primitive("collection-Set-int?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collectionP);
	STk_add_new_cpp_primitive("mset-Set-int1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::buildMSet);
	STk_add_new_cpp_primitive("set-Set-int1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::buildSet);
	STk_add_new_cpp_primitive("sequence-Set-int1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Set-int-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-int-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Set-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Set-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Set-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Set-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collection2STkList);
	STk_add_new_cpp_primitive("set-Set-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Set-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Set-int->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collection2STkString);
	STk_add_new_cpp_primitive("set-Set-int->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Set-int->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_int_>::collection2STkString);
	STk_add_new_cpp_primitive("Collection-Set-int-cartesian-product", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<int >::cartesianProduct);
	STk_add_new_cpp_primitive("Collection-Set-int-choose", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<int >::choose);
	STk_add_new_cpp_primitive("Collection-Set-int-power-set", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<int >::powerSet);
	STk_add_new_cpp_primitive("Collection-Set-int-permutations", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<int >::permutations);
	STk_add_new_cpp_primitive("Collection-Set-int-permutation", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<int >::permutation);
	STk_add_new_cpp_primitive("Collection-Set-int-permutation-rank", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<int >::rank);

	addListMethod("mset-Set-int",
		"mset-Set-int1", LINK_NEW);
	addListMethod("set-Set-int",
		"set-Set-int1", LINK_NEW);
	addListMethod("sequence-Set-int",
		"sequence-Set-int1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Set_int__ >::name, 
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Set_int_ >::name, 
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Set_int__ >::name, 
		"<integer>",
		"Collection-Set-int-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Set_int_ >::name, 
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Set_int_ >::name, 
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Set_int_ >::name, 
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Set_int__ >::name, 
		"Collection-Set-int--", LINK_OVL);
	addTwoArgMethod("cartesian-product",
		Wrapper<_Set_int_ >::name, 
		Wrapper<_Set_int_ >::name, 
		"Collection-Set-int-cartesian-product", LINK_NEW);
	addTwoArgMethod("choose",
		Wrapper<_Set_int_ >::name, 
		"<integer>",
		"Collection-Set-int-choose", LINK_NEW);
	addOneArgMethod("power-set",
		Wrapper<_Set_int_ >::name, 
		"Collection-Set-int-power-set", LINK_NEW);
	addOneArgMethod("permutations",
		Wrapper<_Set_int_ >::name, 
		"Collection-Set-int-permutations", LINK_NEW);
	addTwoArgMethod("permutation",
		Wrapper<_Set_int_ >::name, 
		"<integer>",
		"Collection-Set-int-permutation", LINK_NEW);
	addOneArgMethod("permutation-rank",
		Wrapper<_Set_int_ >::name, 
		"Collection-Set-int-permutation-rank", LINK_NEW);
	genExtra_Collection_Set_int__Methods();
	return UNDEFINED;
}
